apiVersion: apps/v1
kind: Deployment
metadata:
  name: contact-be-deployment
  namespace: {{ .Release.Namespace }}
spec:
  selector:
    matchLabels:
      app: contact-be-container
  template:
    metadata:
      labels:
        app: contact-be-container
      annotations:
        checksum/config1: {{ include (print $.Template.BasePath "/contact-be-configmap.yaml") . | sha256sum }}
    spec:
      initContainers:
        - name: init-db
          image: postgres:9.6.22-alpine3.14
          imagePullPolicy: IfNotPresent
          env:
            - name: APP_DB_ROLE
              value: cbd_service
            - name: APP_DB_PASSWORD
              value: cbd_service
            - name: APP_DBNAME
              value: ContactBaseData{{ .Values.shortNameEnv | title }}
            - name: PGHOST
              value: postgresql-svc.{{ .Values.sharedEnvironment }}.svc.cluster.local
            - name: PGUSER
              value: postgres
            - name: PGPASSWORD
              valueFrom:
                secretKeyRef:
                  name: postgresql-secrets
                  key: POSTGRES_DB_PASSWORD
          command:
          - /bin/sh
          - -c
          - >
            echo Waiting for DB to be ready...;
            while ! pg_isready >dev/null; do sleep 3; done;
            echo DB is ready and accepting conncetions;
            sleep 3;
            echo Creating database ${APP_DBNAME} if not exists;
            psql -tc "SELECT 1 FROM pg_database WHERE datname = '${APP_DBNAME}'" | grep -q 1 || psql -U postgres -c "CREATE DATABASE \"${APP_DBNAME}\"";
            echo Creating role ${APP_DB_ROLE} if not exists;
            psql -tc "SELECT 1 FROM pg_user WHERE usename = '${APP_DB_ROLE}'" | grep -q 1 || psql -c "CREATE USER \"${APP_DB_ROLE}\" WITH PASSWORD '${APP_DB_PASSWORD}'";
            echo Job finished;
        - name: schema-migration
          image: "{{ .Values.imageDatabase.repository }}:{{ .Values.imageDatabase.tag }}"
          imagePullPolicy: Always
          env:
            - name: FLYWAY_URL
              value: jdbc:postgresql://postgresql-svc.{{ .Values.sharedEnvironment }}.svc.cluster.local:5432/ContactBaseData{{ .Values.shortNameEnv | title }}
            - name: FLYWAY_USER
              value: postgres
            - name: FLYWAY_PASSWORD
              valueFrom:
                secretKeyRef:
                  name: postgresql-secrets
                  key: POSTGRES_DB_PASSWORD
          command: ["flyway", "info" ,"migrate", "info"]
      containers:
        - image: "{{ .Values.image.repository }}:{{ .Values.image.tag }}"
          name: contact-be-container
          env:
            - name: SPRING_CONFIG_LOCATION
              value: 'file:/config/'
            - name: APP_DB_ROLE
              value: cbd_service
            - name: APP_DB_PASSWORD
              value: cbd_service
            - name: APP_DBNAME
              value: ContactBaseData{{ .Values.shortNameEnv | title }}
            - name: DATASOURCE_URL
              value: jdbc:postgresql://postgresql-svc.{{ .Values.sharedEnvironment }}.svc.cluster.local/$(APP_DBNAME)
          ports:
            - containerPort: 9155
          volumeMounts:
            - name: config-volume
              mountPath: /config/
              readOnly: true
      volumes:
        - name: config-volume
          configMap:
            name: contact-be-config
            items:
            - key: application.yml
              path: application_localdev.yml
---
apiVersion: v1
kind: Service
metadata:
  name: contact-be-service
  namespace: {{ .Release.Namespace }}
spec:
  selector:
    app: contact-be-container
  ports:
    - protocol: TCP
      port: 9155
      targetPort: 9155